#include <iostream>
#include <list>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <queue>
#include <algorithm>
//
#include <stdio.h>
#include <assert.h>
#include <string.h>

#include "Solver.h"
#include "SimpSolver.h"
using namespace std;

#include "d0efs.hh"


//
//  PRINT_ERR_REPORT1
//
void VerPqe::print_err_report1(char *root,int ind)
{

  char fname[MAX_NAME];
  strcpy(fname,root);

  strcat(fname,".report");
  
  FILE *fp = fopen(fname,"w");
  assert(fp != NULL);

  print_err_header(fp,root);

  fprintf(fp,"\n ====================\n");
  fprintf(fp,"   error report\n");
  fprintf(fp," ====================\n");

  fprintf(fp,"F does not imply G*\n");
  fprintf(fp,"Namely, it does not imply the clause:\n");
  fprintf(fp,"    G*[%d] = ",ind);
  print_symb_cube(fp,Sol[ind]);
} /* print_err_report1 */


//
//  CHECK_SOL
//
int VerPqe::check_sol()
{
  Msolver *Aux_slvr = init_sat_solver(num_vars);
  accept_new_clauses(Aux_slvr,F);

  for (uint i=0; i < Sol.size(); i++) {
    CUBE &C = Sol[i];
    MvecLits Assmps;
    add_negated_assumps(Assmps,C);
    bool sat = Aux_slvr->solve(Assmps);
    if (sat) {
      delete Aux_slvr;
      return(i);
    }
  }
  return(-1);
}  /* check_sol */
